(document:surround "/std/frame")

(define displaysize (make-widget "displaysize"))

;;;;;;;;;;;;;;;;;;;;;;
(define (update-depth-and-rr xres)
  (if (equal? xres "auto")
	(begin
	  (depth value "auto")
	  (depth activity #f)
	  (refresh_rate state #f)
	  (refresh_rate activity #f))
	(begin
	  (depth activity #t)
	  (refresh_rate activity #t))))

(define (update-displaysize-using is_use)
    (displaysize_box visibility is_use)
)

(define (apply-data url really)
    (woo-write url
        'commit really
        'xdepth (depth value)
        'xresolution (resolution value)
        'xdisplay_width (display_width value)
        'xdisplay_height (display_height value)
        'xdisplaysize_use (displaysize_use value)
		'refresh_rate (refresh_rate state))
	(and really
		 (document:popup-warning (_ "Changes will take effect after reboot"))))


;; save data if url changed
(define (change url)
  (apply-data "/x11" #f)
  (frame:replace url))

;;;;;;;;;;;;;;;;;;;;;;;;; ui

(document:id config-x11 (checkbox state #f visibility #f))
(gridbox 
  columns "10;0;80;10"
  ;;
  (spacer)
  (label text (bold (_ "Detected hardware")) align "right")
  (spacer)
  (spacer)

  ;;
  (spacer)
  (label text (_ "Video card:") align "right")
  (document:id auto-card (label))
  (spacer)

  ;;
  (spacer)
  (separator colspan 2)
  (spacer)

  ;;
  (spacer)
  (label text (bold (_ "Current settings")) align "right")
  (spacer)
  (spacer)

  ;;
  (spacer)
  (label text (_ "Driver:") align "right")
  (hbox
    align "left"
    (document:id driver (label))
    (document:id ch-drv (button text (_ "Other driver..."))))
  (spacer)

  ;;
  (spacer)
  (label text (_ "Color depth:") align "right")
  (document:id depth (combobox align "left"))
  (spacer)

  ;;
  (spacer)
  (label text (_ "Resolution:") align "right")
  (document:id resolution (combobox align "left"))
  (spacer)
  ;;
  (spacer)(spacer)
  (document:id refresh_rate (checkbox align "left" visibility #f text (_ "Don't use automatic refresh rate")))
  (spacer)

  ;;
  (spacer)
  (label text (_ "Specify display size:") align "right")
  (gridbox columns "1;1;98"
    (document:id displaysize_use (checkbox ""))
    (document:id displaysize_box
	(gridbox columns "1;1;1;1;98"
	    (document:id display_width  (spinbox align "left" step 1 minimum 0 maximum 10000))
	    (label "×")
	    (document:id display_height (spinbox align "left" step 1 minimum 0 maximum 5000))
	    (label (_ "mm"))
	    (spacer)
	)
    )
    (gridbox columns "1;1;1;98" (label (_ "(detected")) (displaysize) (label (_ "mm)")))
  )
  (spacer)

  ;;
  (label colspan 4)

  ;;
  (spacer)
  (spacer)
  (hbox
    align "left"
    (or (global 'frame:next-button)
	(button text (_ "Apply")
		(when clicked (apply-data "/x11" #t))))
    (document:id quit-btn 
      (button text (_ "Quit") visibility #f
        (when clicked (document:end)))))
  (spacer))

;;;;;;;;;;;;;;;;;;; actions
(ch-drv (when clicked (change "/x11/driver")))
(resolution (when changed (update-depth-and-rr (resolution value))))
(displaysize_use (when changed (update-displaysize-using (displaysize_use value))))

;;;;;;;;;;;;;;;;;;; installer specific
(frame:on-next (thunk (or (apply-data "/x11" #t) 'cancel)))

(document:root
  (when loaded
    (woo-catch/message
      (thunk
        (let* ((data (woo-read-first "/x11"))
			   (xres (woo-get-option data 'xresolution "")))
            (auto-card text (woo-get-option data 'auto_cardname))
            (driver text (woo-get-option data 'xdrivername ""))
            (quit-btn visibility (woo-get-option data 'config_x11 #f))
	    (resolution enumref "/x11/avail_xresolution"
		        value xres)
		(refresh_rate visibility (not (woo-get-option data 'compat_mode)))
		(refresh_rate state (woo-get-option data 'refresh_rate))
            (display_width value (woo-get-option data 'xdisplay_width))
            (display_height value (woo-get-option data 'xdisplay_height))
            (if (and (> (string->number (display_width value)) 50) (> (string->number (display_height value)) 30)) (displaysize_use value #t) (displaysize_use value #f))
            (update-displaysize-using (displaysize_use value))
	    (depth enumref "/x11/avail_xdepth"
	           value (woo-get-option data 'xdepth ""))
		(update-depth-and-rr xres))))))
